#pragma once
#include <memory>
#include <vector>

#include "Shape.h"
class Drawing;

class Group : public Shape {
 public:
  explicit Group(const pugi::xml_node& node, Group* parent, Drawing *drawing);
  Group(std::string const& label, double x, double y, Group* parent);
  void add_child(std::unique_ptr<Shape> shape);
  void clone_with_new_parent(Group* parent) override;
  void draw(SFML_output* out, double x_origin, double y_origin) const override;
  [[nodiscard]] std::string dump(std::string const& indent) const override;
  [[nodiscard]] Shape* find_shape_by_label(std::string_view a_label) override;
  void set_color(std::string const& aColor) override;

 private:
  std::vector<std::unique_ptr<Shape>> children;
};
