#include <sstream>
#include "SymbolDefinition.h"

using namespace std;

SymbolDefinition::SymbolDefinition(const pugi::xml_node& node) :
  label(node.attribute("label").as_string()),
  root{ make_unique<Group>(node, nullptr, nullptr) }
{
}

void SymbolDefinition::draw(SFML_output* out, const double x_origin, const double y_origin) const {
  root->draw(out, x_origin, y_origin);
}

std::string SymbolDefinition::dump(std::string const& indent) const {
  ostringstream oss;
  oss << indent << "SymbolDefinition with root = " << root->dump(indent);
  return oss.str();
}

Shape* SymbolDefinition::find_shape_by_label(const std::string_view a_label) const {
  return root->find_shape_by_label(a_label);
}

std::string SymbolDefinition::get_label() const {
  return label;
}

void SymbolDefinition::set_color(std::string const& aColor) const {
  root->set_color(aColor);
}
