#pragma once
#include "symbols_and_intelligent_pointers.h"
#if SYMBOL_USES_UNIQUE_PTR_AND_NOT_SHARED_PTR == 0
#include <memory>
#endif // SYMBOL_USES_UNIQUE_PTR_AND_NOT_SHARED_PTR == 0
#include "Shape.h"

class Drawing;
class SymbolDefinition;

class SymbolReference : public Shape {
public:
  explicit SymbolReference(const pugi::xml_node& node, Group* parent, Drawing *drawing);
#if SYMBOL_USES_UNIQUE_PTR_AND_NOT_SHARED_PTR == 1
  SymbolReference(std::string const& label, double x, double y, Group *parent, const SymbolDefinition *symbol_definition);
#else // SYMBOL_USES_UNIQUE_PTR_AND_NOT_SHARED_PTR == 1
  SymbolReference(std::string const& label, double x, double y, Group *parent, std::shared_ptr<SymbolDefinition> symbol_definition);
#endif // SYMBOL_USES_UNIQUE_PTR_AND_NOT_SHARED_PTR == 1
  void clone_with_new_parent(Group* parent) override;
  [[nodiscard]] std::string dump(std::string const& indent) const override;
  void draw(SFML_output* out, double x_origin, double y_origin) const override;
  void set_color(std::string const& aColor) override;

private:
#if SYMBOL_USES_UNIQUE_PTR_AND_NOT_SHARED_PTR == 1
  const SymbolDefinition *symbol_definition;
#else // SYMBOL_USES_UNIQUE_PTR_AND_NOT_SHARED_PTR == 1
  std::shared_ptr<SymbolDefinition> symbol_definition;
#endif // SYMBOL_USES_UNIQUE_PTR_AND_NOT_SHARED_PTR == 1
};

