#include "myMain.h"

#include <iostream>

#include "Drawing.h"

using namespace std;

void modify_drawing(const Drawing &d) {
  d.find_shape_by_label("nez")->set_color("Yellow");
  d.find_shape_by_label("c22")->translate(-10,-10);
  d.find_shape_by_label("oreille1")->clone();  // Le groupe "oreille1" est cloné en un groupe de label
  // "oreille1+" contenant les cercles "ci1+" et "ci2+",
  // clones de "ci1" et "ci2".
  cout << d.dump("") << endl;
  d.find_shape_by_label("oreille1+")->set_color("Blue");
  d.find_shape_by_label("oreille1+")->translate(0, -455);
  d.find_shape_by_label("c12+")->translate(210, -30);
  d.find_shape_by_label("c11+")->set_color("Cyan");
  d.find_shape_by_label("c11+")->clone(); // Le cercle "c11+" est cloné en cercle "c11++".
  d.find_shape_by_label("c11++")->translate(420, 0);
  d.find_shape_by_label("iris")->translate(0, -10);
  cout << d.dump("") << endl;
}

int myMain() {
  pugi::xml_document doc;
  if (const auto result = doc.load_file("res/visage.xml"); !result) {
    std::cerr << "Could not open file visage.xml because "
              << result.description() << std::endl;
    return 1;
  }

  Drawing d(doc.child("Drawing"));

  modify_drawing(d);

  SFML_output out;
  out.display(d);
  return 0;
}
